#include <stdio.h>
#include <fcntl.h>

#include "server.h"
#include "parson.h"

#define STX (0x02)
#define ETX (0x03)

extern struct client client[];

struct dialog_top{
	int sw[2];
	int led[2];
	int slide[2];
}dialog_top;

int led_out(int led, int val)
{
	char *devname;
	int fd;
	char c;
	int ret;

	if(led==0)
		devname = "/dev/led0";
	else if(led==1)
		devname = "/dev/led1";
	else if(led==2)
		devname = "/dev/led2";
	else if(led==3)
		devname = "/dev/led3";
	else
		return -1;

	fd = open(devname, O_WRONLY);
	if(fd<0){
		perror(devname);
		exit(1);
	}

	if(val==0)
		c='0';
	else if(val==1)
		c='1';
	else
		return -1;
	
	ret=write(fd, &c, 1);
	if(ret<0){
		perror(devname);
		exit(1);
	}

	close(fd);
	return 0;
}



/* AttrAbvf[gJSONR}hdPNCAgɑM */

int send_cmd_attr_update(int sd, unsigned char *name, unsigned char *attr, unsigned char *title)
{
	int ret;
	unsigned char str[1024];
	
	ret = sprintf(str,"%c{'Command':'UPDATE','Object':{'Name':'%s','Attr':'%s','Title':'%s'}}%c",
		STX, name, attr, title, ETX);

	printf("%s() %s\n",__func__,str);

	ret = write(sd, str, ret);

	return ret;
}

/* ValueAbvf[gJSONR}hdPNCAgɑM */

int send_cmd_value_update(int sd, unsigned char *name, unsigned char *Value, unsigned char *title)
{
	int ret;
	unsigned char str[1024];
	
	ret = sprintf(str,"%c{'Command':'UPDATE','Object':{'Name':'%s','Value':'%s','Title':'%s'}}%c",
		STX, name, Value, title, ETX);

	printf("%s() %s\n",__func__,str);

	ret = write(sd, str, ret);

	return ret;
}

/* _CAONCAgɑ */

int send_dialog_top_info(int sd)
{
	int ret;
	int i;
	char name[16];
	char attr[16];
	char val[16];

	for(i=0; i<2; i++){
		sprintf(name,"sw%d",i);
		if(dialog_top.sw[i] == 1){
			sprintf(attr,"ON");
		}
		if(dialog_top.sw[i] == 0){
			sprintf(attr,"OFF");
		}
		ret = send_cmd_attr_update(sd, name, attr, attr);
		if(ret<0)
			return ret;
	}

	for(i=0; i<2; i++){
		sprintf(name,"led%d",i);
		if(dialog_top.led[i] == 1){
			sprintf(attr,"ON");
		}
		if(dialog_top.led[i] == 0){
			sprintf(attr,"OFF");
		}
		ret = send_cmd_attr_update(sd, name, attr, attr);
		if(ret<0)
			return ret;
	}

	for(i=0; i<2; i++){
		sprintf(name,"val%d",i);
		sprintf(val,"%d",dialog_top.slide[i]);
		ret = send_cmd_value_update(sd, name, val, val);
		if(ret<0)
			return ret;
	}

	return 0;
}


/* _CAONCAgɑ */

int send_dialog_info(int sd, char *DialogName)
{
	if(strcmp(DialogName,"Top")==0){
		return send_dialog_top_info(sd);
	}
	return 0;
}

/* SڑNCAgɃ_CAO𑗂 */

int send_dialog_info_all(char *DialogName)
{
	int i;
	int ret;
	for(i=0; i<MAX_CONNECT; i++){
		int sd;
		sd = client[i].sd;
		if(sd==0){
			continue;
		}
		ret = send_dialog_info(sd, DialogName);
		if(ret<0){
			close(sd);
			client[i].sd = 0;
			return ret;
		}
	}
	return 0;
}

/* t@Cɓǂݍ */
int file_to_buf(unsigned char *buf, int count, const unsigned char *file_name)
{
	int fd;
	int len;
	fd = open(file_name,O_RDONLY);
	if(fd<0){
		printf("%s():%d error\n",__func__,__LINE__);
		return -1;
	}
	len = read(fd, buf, count);
	close(fd);
	return len;
}

/* JSONt@C𑗐M */
int send_json_file(int sd, const unsigned char *file_name)
{
	unsigned char file_buff[65536];
	int len;
	printf("%s(%s)\n",__func__,file_name);

	file_buff[0] = STX;
	len = file_to_buf(&file_buff[1], sizeof(file_buff)-3, file_name);
	if(len<0){
		printf("%s():%d error\n",__func__,__LINE__);
		return len;	/* ERROR */
	}
	printf("len=%d\n",len);
	file_buff[len+1] = ETX;
	file_buff[len+2] = 0;
	len = write(sd, file_buff, len+2);
	if(len<0){
		printf("%s():%d error\n",__func__,__LINE__);
		return len;	/* ERROR */
	}
	return 0;
}

int Action_Clicked(char *Name, char *Attr)
{
	int led;
	int val;
	int ret;

	if(strcmp(Name,"led0")==0)
		led=0;
	else if(strcmp(Name,"led1")==0)
		led=1;
	else
		return -1;

	if(strcmp(Attr,"ON")==0)
		val=1;
	else if(strcmp(Attr,"OFF")==0)
		val=0;
	else
		return -1;

	/* \́iTjAbvf[g */
	dialog_top.led[led] = val;

	/* foCX֏o */
	led_out(led, val);

	/* SڑNCAgɃ_CAO𑗂 */
	ret = send_dialog_info_all("Top");

	return ret;
}

int Action_SlideMoved(char *Name, char *Value)
{
	int slide;
	int val;
	int ret;

	if(strcmp(Name,"val0")==0)
		slide=0;
	else if(strcmp(Name,"val1")==0)
		slide=1;
	else
		return -1;

	val = atoi(Value);

	/* \́iTjAbvf[g */
	dialog_top.slide[slide] = val;

	/* foCX֏o */
	if((val>=0)&&(val<49))
		led_out(slide+2, 0);

	if((val>=50)&&(val<100))
		led_out(slide+2, 1);

	/* SڑNCAgɃ_CAO𑗂 */
	ret = send_dialog_info_all("Top");

	return ret;
}



/* eR}hƂ̏ */

int cmd_hello(int sd, const char *id_str, const char *passwd_str)
{
	printf("%s(%s,%s)\n",__func__,id_str, passwd_str);
	return 0;
}


int json_parse(int sd, const char *str)
{
	int ret=0;

    JSON_Value *root_value;
    JSON_Object *object;

	char *cmd_str=NULL;

	root_value = json_parse_string(str);
	if(root_value == NULL){
		printf("root_value is NULL\n");
		return -1;
	}

	/* NCAg瑗Ă JSONp[XA
	   R}h𔲂oĕ򂷂 */
	object = json_value_get_object(root_value);
	cmd_str = json_object_dotget_string (object, "Command");
	if(cmd_str){
		printf("cmd_str = %s\n",cmd_str);

		/* "HELLO" R}h̏ꍇ */
		if(strcmp(cmd_str,"HELLO")==0){
			char *id_str;
			char *passwd_str;
			id_str = json_object_dotget_string (object, "Id");
			passwd_str = json_object_dotget_string (object, "Pass");
			ret = cmd_hello(sd, id_str, passwd_str);
			if(ret<0)
				return ret;
			/* ŏ Top.json 𑗂ăgbvʂ\ */
			ret = send_json_file(sd, "resources/Top.json");
		}

		/* "CHANGE" R}h̏ꍇ */
		if(strcmp(cmd_str,"CHANGE")==0){
			char *DialogName;
			DialogName = json_object_dotget_string (object, "DialogName");
			send_dialog_info(sd, DialogName);
		}

		/* "CONDITION" R}h̏ꍇ */
		if(strcmp(cmd_str,"CONDITION")==0){
			char *ActionType=NULL;
			JSON_Array *array;
			size_t index;

			ActionType = json_object_dotget_string (object, "ActionType");

			array = json_object_get_array(object, "Objects");
			if(array){
				int i, count;
				count = json_array_get_count  (array);
				for(i=0; i<count; i++){
					JSON_Object *object_target;
					char *Name=NULL;
					char *Attr=NULL;
					char *Value=NULL;
					object_target = json_array_get_object (array, i);
					Name = json_object_dotget_string (object_target, "Name");
					Attr = json_object_dotget_string (object_target, "Attr");
					Value = json_object_dotget_string (object_target, "Value");

					printf("ActionType=%s, Name=%s, Attr=%s,Value=%s \n", ActionType, Name, Attr, Value);

					/* {^NbN */
					if(strcmp(ActionType,"Clicked")==0){
						Action_Clicked(Name, Attr);
					}

					/* XCho[𓮂 */
					if(strcmp(ActionType,"SlideMoved")==0){
						Action_SlideMoved(Name, Value);
					}
				}
			}
		}
	}
	return ret;
}

/* NCAg JSONdǂ */

int data_event(struct client *client)
{
	int ret ,i;
	int sd = client->sd;
	unsigned char buff[65536];
	unsigned char *stx, *etx;

	/* Androidpbh痈TCPdǂ */
	ret = read(sd, buff, sizeof(buff));
	if(ret < 0){
		return ret;	/* ERROR */
	}
	if(ret == 0){
		return -1;	/* EOF */
	}

	stx = NULL;
	etx = NULL;

	/* STX, ETX TA '  " ɕύX */
	for(i=0; i<ret; i++){
		unsigned char c = buff[i];
		if(c=='\''){
			buff[i]='\"';
		}
		else if(c==STX){
			stx = &buff[i];
		}
		else if(c==ETX){
			etx = &buff[i];
			buff[i]=0;
			break;
		}
	}

	if(stx==NULL){
		printf("STX not found\n");
		return 0;	/* close */
	}
	if(etx==NULL){
		printf("ETX not found\n");
		return 0;	/* close */
	}

	printf("%s\n",stx+1);
	ret = json_parse(sd, stx+1);	/* JSONp[X */

	return ret;
}

/* SWCxg */

int sw_event(int fd)
{
	int ret;
	char str[16];
	int sw;
	int val;

	ret = read(fd, str, sizeof(str));
	if(ret<=0){
		return -1;
	}

	if(str[0]=='0')
		sw=0;	/* SW0 */
	else if(str[0]=='1')
		sw=1;	/* SW1 */
	else
		return -1;

	if(str[1]=='D')
		val=1;	/* SW(Down) */
	else if(str[1]=='U')
		val=0;	/* SW𗣂(Up) */
	else
		return -1;

	/* \́iTjAbvf[g */
	dialog_top.sw[sw] = val;

	/* SڑNCAgɃ_CAO𑗂 */
	ret = send_dialog_info_all("Top");
	return ret;
}



/* ^CAEgCxg */

void timeout_event(void)
{
	printf("Timeout\n");
}
